#########################################################################
# SopcastSports
# Daniel Bardsley
# daniel@bardsley.org.uk
# created: 17/12/07
#########################################################################
# gamedata.tcl
# Procedures for adding and removing to internal data strictures
#########################################################################

proc addgame {game link} {
	global livegames

	incr livegames(ID)
	set id $livegames(ID)
	
	set livegames($id,game) $game
	set livegames($id,link) $link
}

proc addlink {gameid link game} {
	global livegameslinks
	
	incr livegameslinks(ID)
	set id $livegameslinks(ID)
	
	set livegameslinks($id,gameid) $gameid
	set livegameslinks($id,link) $link
	set livegameslinks($id,game) $game
}

proc addstream {channel stream filehandle port game} {
	global openchannels
	
	set openchannels(ID) $channel	
	set id $openchannels(ID)
	
	set openchannels($id,stream) $stream
	set openchannels($id,filehandle) $filehandle
	set openchannels($id,port) $port
	set openchannels($id,game) $game
	set openchannels($id,up) 0
	set openchannels($id,down) 0
	set openchannels($id,nPeers) 0
	set openchannels($id,buffer) 0
	
	puts "adding stream $id $stream $filehandle $port"
}

proc removestream {channel} {
	global openchannels
	global freechannels
	
	unset openchannels($channel,stream)
	unset openchannels($channel,filehandle)
	unset openchannels($channel,port)
	unset openchannels($channel,game)
	unset openchannels($channel,up)
	unset openchannels($channel,down)
	unset openchannels($channel,nPeers)
	unset openchannels($channel,buffer)
	
	lappend freechannels $channel
	set freechannels [lsort $freechannels]
	
	puts "removing stream $channel"
}
